/*
 *  Video Lightning - v3.0.9
 *  Turn any element into a lightbox or popover link for Youtube and Vimeo videos.
 *  https://github.com/musocrat/jquery-video-lightning/
 *
 *  Made by Andrew Carpenter @ Musocrat
 *  Published under MIT License
 */

(function(){var t=function(t,i){return function(){return t.apply(i,arguments)}};!function(i){var e,s,o,n,r,h,a,l,p,d,u,c,y,f,g,v,m,w,b,x,P,T,k,E,L,_,I,S,z,B,C,D,A;if(B=i,D=this,C=function(t){var i,s,o,n,r,h,a,l,p,d,u,c,f,w,x,P,T;if(f=function(){console.error("VideoLightning was initialized without elements.")},!(w=t.elements||t.element))return f();if(P=[],n=[],x=function(t){var i;return b(t)?P.push({el:t,opts:null}):(i=L(t),P.push({el:i,opts:t[i]||null}))},v(w))for(r=0,l=w.length;r<l;r++)x(w[r]);else x(w);for(h=0,p=P.length;h<p;h++)if(o=P[h],s=y(o.el))if(m(s))for(a=0,d=s.length;a<d;a++)i=s[a],n.push({el:i,opts:o.opts});else n.push({el:s,opts:o.opts});if(0===n.length)return f();for(T=t.settings||{},c=0,u=n.length;c<u;c++)(o=n[c])&&D.vlData.instances.push(new e(o,T));g()},e=function(){function i(i,e){this.elObj=i,this.vmStop=t(this.vmStop,this),this.vmPlay=t(this.vmPlay,this),this.vmListen=t(this.vmListen,this),this.initPlayerVM=t(this.initPlayerVM,this),this.coverYT=t(this.coverYT,this),this.ytState=t(this.ytState,this),this.ytStop=t(this.ytStop,this),this.ytPlay=t(this.ytPlay,this),this.setYTPlayer=t(this.setYTPlayer,this),this.initPlayerYT=t(this.initPlayerYT,this),this.cover=t(this.cover,this),this.hide=t(this.hide,this),this.show=t(this.show,this),this.clear=t(this.clear,this),this.stop=t(this.stop,this),this.play=t(this.play,this),this.peek=t(this.peek,this),this.hovered=t(this.hovered,this),this.clicked=t(this.clicked,this),this.regEvents=t(this.regEvents,this),this.resize=t(this.resize,this),this.popoverPos=t(this.popoverPos,this),this.buildEls=t(this.buildEls,this),this.buildOpts=t(this.buildOpts,this),this.opts=a({},e),this.inst=T(),this.el=this.elObj.el,this.buildOpts(),this.buildEls(),o(this.opts.cover,!1)&&this.cover(),this.regEvents()}return i.prototype.buildOpts=function(){var t,i,e,s,o,n,r,h,l,p,d,u,c,y,f,g,v;if(y=[["backdrop_color","bdColor"],["backdrop_opacity","bdOpacity"],["ease_in","fadeIn"],["ease_out","fadeOut"],["glow_color","glowColor"],["start_time","startTime"],["z_index","zIndex"],["rick_roll","rickRoll"],["iv_load_policy","ivLoadPolicy"]],a(this.opts,this.elObj.opts),0===(s=this.el.dataset||[]).length)for(o=0,l=(c=["id","width","height"]).length;o<l;o++)r=c[o],(g=this.el.getAttribute("data-video-"+r))&&(s[r]=g);v=this,u=function(t,i){return v.opts[t.replace(/^video(.)(.*)/,function(t,i,e){return i.toLowerCase()+e})]=i};for(r in s)u(r,g=s[r]);for(this.opts.width=this.opts.width?parseInt(this.opts.width,10):640,this.opts.height=this.opts.height?parseInt(this.opts.height,10):390,e=this.opts.height/this.opts.width,!this.opts.fullscreenAllowed&&this.opts.width>window.innerWidth-90&&(this.opts.width=window.innerWidth-90,this.opts.height=Math.round(e*this.opts.width)),null==(t=this.opts).id&&(t.id="y-dQw4w9WgXcQ"),this.opts.id.match(/^v/)?(this.vendor="vimeo",this.vm=!0):this.opts.id.match(/^f/)?(this.vendor="iframe",this.ifr=!0):(this.vendor="youtube",this.yt=!0),window.vlData[this.vendor]=!0,this.id=this.opts.id.replace(/([vyf]-)/i,""),f=[],n=0,p=y.length;n<p;n++)h=y[n],f.push(null!=(i=this.opts)[d=h[1]]?i[d]:i[d]=this.opts[h[0]]);return f},i.prototype.buildEls=function(){var t,i,e,s,r,a,l,p,d,y;return(this.target=B.createElement("span")).className="video-target",this.el.parentNode.insertBefore(this.target,this.el),this.target.appendChild(this.el),i=n(_(this.opts.bdColor,"#ddd")),e=_(this.opts.bdOpacity,.6),t="background: rgba("+i.r+", "+i.g+", "+i.b+", "+e+");",s="width: "+this.opts.width+"px; height: "+this.opts.height+"px;",a="margin-top: -"+this.opts.height/2+"px; margin-left: -"+this.opts.width/2+"px;",r="box-shadow: 0px 0px "+(p=_(this.opts.glow,20))+"px "+p/5+"px "+c(_(this.opts.glowColor,"#000"))+";",d=o(this.opts.popover,!1)?S(this.opts.width,this.opts.height):I,y="background: "+c(_(this.opts.xBgColor,"#000"))+"; color: "+c(_(this.opts.xColor,"#fff"))+"; border: "+_(this.opts.xBorder,"none")+"; box-sizing: border-box;",l="background: "+c(_(this.opts.frameColor,"#000"))+"; border: "+_(this.opts.frameBorder,"none")+"; box-sizing: border-box;",this.target.insertAdjacentHTML("beforeend",h({tag:"div",attrs:{id:"wrap_"+this.inst,class:"video-wrapper",style:d+" "+t+" z-index: "+_(this.opts.zIndex,2100)+"; opacity: 0;"},children:[{tag:"div",attrs:{class:"video-frame",style:u+" "+s+" "+a+" "+r},children:[{tag:"div",attrs:{class:"video"},children:[{tag:"div",inner:"&times;",attrs:{id:"close_"+this.inst,class:"video-close",style:"float: right; margin-right: -34px; "+r+" "+y+" padding: 0 10px 0 12px; font-size: 25px;"}},{tag:"iframe",attrs:{type:"text/html",id:"iframe_"+this.inst,class:"video-iframe",style:"position: absolute; top: 0; left: 0; "+l}}]}]}]})),this.wrapper=B.getElementById("wrap_"+this.inst),this.iframe=B.getElementById("iframe_"+this.inst),this.close=B.getElementById("close_"+this.inst)},i.prototype.popoverPos=function(){var t;return t=f(this.target,this.opts.width,this.opts.height,this.opts.fluidity),this.wrapper.style.left=t.x+"px",this.wrapper.style.top=t.y+"px"},i.prototype.resize=function(){if(!window.vlData.throttle&&(this.popoverPos(),this.opts.throttle))return window.vlData.throttle=!0,setTimeout(function(){return window.vlData.throttle=!1},this.opts.throttle)},i.prototype.regEvents=function(){if(this.target.style.cursor="pointer",this.target.addEventListener("mouseup",this.clicked,!1),o(this.opts.popover,!1)&&(window.addEventListener("resize",this.resize,!1),window.addEventListener("scroll",this.resize,!1),window.addEventListener("orientationchange",this.resize,!1),this.opts.peek))return this.target.addEventListener("mouseenter",this.hovered,!1),this.target.addEventListener("mouseleave",this.hovered,!1)},i.prototype.clicked=function(t){return this.peeking?this.peek(!1,!0):t.buttons&&1!==t.buttons||t.which&&1!==t.which||t.button&&1!==t.button?void 0:this.playing?this.stop():this.play()},i.prototype.hovered=function(t){if("mouseenter"!==t.type||this.playing||this.peek(),"mouseleave"===t.type&&this.playing)return this.peek(this.peeking)},i.prototype.peek=function(t,i){if(null==t&&(t=!1),null==i&&(i=!1),this.peeking||!this.playing)return this.close.innerHTML=t||i?"&times;":"&#94;",this.peeking=!(t||i),t?this.stop():i?null:this.play()},i.prototype.play=function(){o(this.opts.popover,!1)&&this.popoverPos(),this.show(),this.ifr?k(this.iframe,{url:encodeURI(this.id),attrs:{width:this.opts.width,height:this.opts.height,frameBorder:0}}):this.ready&&!this.playing&&"about:blank"!==this.iframe.src?(this.yt&&this.ytPlay(),this.vm&&this.vmPlay()):this.playing||(this.vm&&this.initPlayerVM(),this.yt&&this.initPlayerYT()),this.playing=!0,this.clearAfter&&window.clearTimeout(this.clearAfter)},i.prototype.stop=function(t){null==t&&(t=0),o(this.opts.rickRoll,!1)||(this.hide(t),this.ready?(this.yt&&this.ytStop(),this.vm&&this.vmStop()):this.clear(),this.playing=!1,o(this.opts.unload,!0)&&(this.clearAfter=window.setTimeout(this.clear,1e3*(_(this.opts.unloadAfter)||45))))},i.prototype.clear=function(){this.iframe.src="about:blank"},i.prototype.show=function(){p(this.wrapper,_(this.opts.fadeIn,300))},i.prototype.hide=function(t){null==t&&(t=0),d(this.wrapper,_(this.opts.fadeOut,t))},i.prototype.cover=function(){this.yt&&this.coverYT()},i.prototype.initPlayerYT=function(){if(k(this.iframe,{url:"https://www.youtube.com/embed/"+this.id,params:{enablejsapi:1,autoplay:s(this.opts.autoplay,1),autohide:_(this.opts.autohide,2),cc_load_policy:_(this.opts.ccLoadPolicy,0),color:_(this.opts.color,null),controls:_(this.opts.controls,2),disablekb:_(this.opts.disablekb,0),end:_(this.opts.endTime,null),fs:_(this.opts.fs,1),hl:_(this.opts.hl,"en"),iv_load_policy:_(this.opts.ivLoadPolicy,1),list:_(this.opts.list,null),listType:_(this.opts.listType,null),loop:_(this.opts.loop,0),modestbranding:_(this.opts.modestbranding,0),origin:encodeURIComponent(_(this.opts.origin,location.protocol+"//"+location.host)),playerapiid:this.inst,playlist:_(this.opts.playlist,null),playsinline:_(this.opts.playsinline,0),rel:_(this.opts.rel,0),showinfo:_(this.opts.showinfo,1),start:_(this.opts.startTime,0),theme:_(this.opts.theme,null)},attrs:{width:this.opts.width,height:this.opts.height,frameBorder:0}}),this.iframe.setAttribute("allowFullScreen",""),window.vlData.ytAPIReady)return this.setYTPlayer()},i.prototype.setYTPlayer=function(){var t,i;return i=this,t=function(){return i.ready=!0},null!=this.ytPlayer?this.ytPlayer:this.ytPlayer=new YT.Player("iframe_"+this.inst,{events:{onReady:t,onStateChange:this.ytState}})},i.prototype.ytPlay=function(){return this.ytPlayer.playVideo()},i.prototype.ytStop=function(){z(this.ytPlayer,this.opts.startTime),this.ytPlayer.stopVideo(),this.ytPlayer.clearVideo(),this.opts.startTime&&this.clear()},i.prototype.ytState=function(t){if(0===t.data&&o(this.opts.autoclose,!0))return this.stop(_(this.opts.fadeOut,1e3))},i.prototype.coverYT=function(){this.ytCover=r(this.target,"//img.youtube.com/vi/"+this.id+"/hqdefault.jpg")},i.prototype.initPlayerVM=function(){return k(this.iframe,{url:"https://player.vimeo.com/video/"+this.id,params:{autoplay:s(this.opts.autoplay,1),loop:_(this.opts.loop,0),title:_(this.opts.showinfo,1),byline:_(this.opts.byline,1),portrait:_(this.opts.portrait,1),color:P(_(this.opts.color,"#00adef")),api:1,player_id:this.inst},attrs:{width:this.opts.width,height:this.opts.height,frameBorder:0}}),this.iframe.setAttribute("allowFullScreen",""),window.addEventListener("message",this.vmListen,!1),null!=this.vmPlayer?this.vmPlayer:this.vmPlayer=this.iframe},i.prototype.vmListen=function(t){var i;if((i=JSON.parse(t.data)).player_id===this.inst)switch(i.event){case"ready":this.ready=!0,x(this.vmPlayer,this.id,"addEventListener","finish");break;case"finish":this.stop(1e3)}},i.prototype.vmPlay=function(){x(this.vmPlayer,this.id,"play")},i.prototype.vmStop=function(){x(this.vmPlayer,this.id,"pause"),this.opts.startTime&&this.clear()},i}(),_=function(t,i){return!1===t||"false"===t||0===t||"0"===t?t:t||i},s=function(t,i){return!1===t||"false"===t||0===t||"0"===t?0:!0===t||"true"===t||"1"===t||1===t?1:i},o=function(t,i){return!1!==t&&"false"!==t&&0!==t&&"0"!==t&&(!!t||i)},h=function(t){var i,e,s,o,n,r,a,l;if(i="",s="",t.attrs){a=t.attrs;for(n in a)i+=" "+n+'="'+a[n]+'"'}if(t.children)for(o=0,r=(l=t.children).length;o<r;o++)e=l[o],s+=w(e)?h(e):e;return"<"+t.tag+i+">"+(t.inner||s)+"</"+t.tag+">"},k=function(t,i){var e,s,o,n,r,h;r=i.url+"?",s=i.params;for(e in s)null!==(h=s[e])&&(r+="&"+e+"="+h);t.src=r.replace(/&/,""),o=i.attrs,n=[];for(e in o)h=o[e],n.push(t[e]=h);return n},a=function(t,i){var e,s;for(e in i)s=i[e],t[e]=s;return t},b=function(t){return"string"==typeof t},v=function(t){return t instanceof Array},m=function(t){return t instanceof HTMLCollection||t instanceof NodeList},w=function(t){return null!==t&&"object"==typeof t},L=function(t){var i;for(i in t)return t[i],i},y=function(t){var i;return i="#"===t.charAt(0)?B.getElementById(t.substr(1)):B.getElementsByClassName(t.substr(1)),v(i)&&0===i.length?null:i},T=function(){return(Math.random().toString(36).slice(2)+Math.random().toString(36).slice(2)).substring(0,16)},P=function(t){return 3===(t=t.replace(/^#/,"")).length?""+t+t:t},c=function(t){return"transparent"===t?t:"#"+P(t)},n=function(t){return{r:parseInt(P(t).substring(0,2),16),g:parseInt(P(t).substring(2,4),16),b:parseInt(P(t).substring(4,6),16)}},I="display: none; position: fixed; min-width: 100%; min-height: 100%; top: 0; right: 0; bottom: 0; left: 0;",S=function(t,i){return"display: none; position: fixed; width: "+t+"px; height: "+i+"px;"},u="position: absolute; top: 50%; left: 50%; background: #000000;",l=function(t,i){return t.style.transition=t.style.mozTransition=t.style.webkitTransition="opacity "+i+"ms ease"},p=function(t,i){return l(t,i),t.style.display="block",setTimeout(function(){return t.style.opacity=1},20)},d=function(t,i){return l(t,i),t.style.opacity=0,setTimeout(function(){return t.style.display="none"},i)},g=function(){var t,e,s;B.getElementById("ytScript")||(t=B.getElementsByTagName("script")[0],(e=i.createElement("script")).innerHTML="function onYouTubeIframeAPIReady() {vlData.ytReady()};",t.parentNode.insertBefore(e,t),(s=i.createElement("script")).id="ytScript",s.async=!0,s.src="https://www.youtube.com/iframe_api",e.parentNode.insertBefore(s,e.nextSibling))},z=function(t,i){null==i&&(i=0),t.getDuration()-3<t.getCurrentTime()&&(t.pauseVideo(),t.seekTo(i,!1))},x=function(t,i,e,s){var o;return null==s&&(s=null),o=s?{method:e,value:s}:{method:e},t.contentWindow.postMessage(JSON.stringify(o),"https://player.vimeo.com/video/"+i)},r=function(t,i){var e;return(e=B.createElement("img")).className="video-cover",e.src=i,t.appendChild(e),e},E=function(){var t;return(t=i.getElementById("vl-size-test"))||((t=i.createElement("div")).id="vl-size-test",t.style.cssText="position:fixed;top:0;left:0;bottom:0;right:0;visibility:hidden;",i.body.appendChild(t)),{width:t.offsetWidth,height:t.offsetHeight}},f=function(t,i,e,s){var o,n,r,h,a,l,p,d,u,c,y,f,g,v,m;for(null==s&&(s=30),r=t.getBoundingClientRect(),n={x:(p=E().width)/2,y:(l=E().height)/2},o={x:i/2,y:e/2},d=[],v=h=r.left,u=r.right+i,c=s;c>0?h<=u:h>=u;v=h+=c)d.push([v-i,r.top-e]),d.push([v-i,r.bottom]);for(m=a=r.top,y=r.bottom+e,f=s;f>0?a<=y:a>=y;m=a+=f)d.push([r.left-i,m-e]),d.push([r.right,m-e]);return g=function(t,s){var r,h,a,d,u,c,y,f;for(d=0,u=(f=[[t,c={}],[s,y={}]]).length;d<u;d++)v=(r=f[d])[0][0],m=r[0][1],r[1].diffx=(h=v+o.x)>n.x?h-n.x:n.x-h,r[1].diffy=(a=m+o.y)>n.y?a-n.y:n.y-a,r[1].diff=r[1].diffx+r[1].diffy,(v<0||v+i>p)&&(r[1].diff+=1e4),(m<0||m+e>l)&&(r[1].diff+=1e4);return c.diff-y.diff},d.sort(g),{x:parseInt((v=d[0][0])<0||v+i>p?n.x-o.x:v,10),y:parseInt((m=d[0][1])<0||m+e>l?n.y-o.y:m,10)}},this.videoLightning=C,this.vlData={},this.vlData.instances=[],this.vlData.ytReady=(A=this,function(){return A.vlData.ytAPIReady=!0}),this.vlData.youtube=this.vlData.vimeo=!1,"undefined"!=typeof $)$.fn.jqueryVideoLightning=function(t){return this.each(function(){var i;$.data(this,"plugin_jqueryVideoLightning")||(i=new e({el:this,opts:t}),vlData.instances.push(i),$.data(this,"plugin_jqueryVideoLightning",i))}),g()}}(document)}).call(this);